package fxKirjautuminen;

import javafx.stage.Stage;
import javafx.scene.control.TextField;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;

/**
 * Kysytään uuden pelaajan nimi, ja luodaan dialogi
 * @author Sakari
 * @version 26.1.2025
 *
 */
public class KirjautuminenGUIController implements ModalControllerInterface<String> {

    @FXML private TextField nimiKentta;
    private String pelaajanNimi = null;
    
    
    @FXML private void handleOK() {
        pelaajanNimi = nimiKentta.getText();
        ModalController.closeStage(nimiKentta);
    }
    
    
    @FXML private void handleCancel() {
        ModalController.closeStage(nimiKentta);
    }
    
    @FXML private void handleLisaaKayttaja() {
        Dialogs.showMessageDialog("Lisätään käyttäjä! Mutta ei toimi vielä.");
    }
    
    
    @Override
    public String getResult() {
        return pelaajanNimi;
    }

    
    /*
     * Tehdään, kun dialogi näytetty ruudulla 
     */
    @Override
    public void handleShown() {
        nimiKentta.requestFocus();
    }

    
    @Override
    public void setDefault(String oletus) {
        nimiKentta.setText(oletus);
    }
    
//    public static lueTiedosto() {
//        //TODO
//    }
    
    /**
     * Haetaan nimenkysymisdialogi, ja palautetaan nimi, tai null.
     * @param modalityStage mitä kohtaan ollaan modaalinen, jos null = sovellukselle
     * @param oletus oletusnimi
     * @return nimikenttään kirjoitettu nimi, mutta jos painetaan Cancel, niin null.
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                KirjautuminenGUIController.class.getResource("KirjautuminenGUIView.fxml"), 
                "Pelaaja1", modalityStage, oletus);
    }
}