package fxTulosKortti;
import java.io.IOException;

import fi.jyu.mit.fxgui.Dialogs;
//import fi.jyu.mit.fxgui.ModalController;
//import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fxKirjautuminen.KirjautuminenGUIController;
import fxUusirata.UusirataGUIController;
import javafx.scene.control.MenuButton;
import javafx.scene.control.MenuItem;
//import fxParhaat.ParhaatGUIController;
//import fxParhaat.ParhaatGUIView.fxml;
import javafx.scene.control.TextField;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import luokat.Pelaaja;
import luokat.Rata;
//import luokat.Pelaajat;
import luokat.Tuloskortti;
import luokat.SailoException;

/**
 * @author Sakari
 * @version 22.1.2025
 *
 */
public class TuloskorttiGUIController implements ModalControllerInterface<String> {
    
    
    
    
    
    //TIEDOSTO - kohdan alla menubarissa olevat napit
    @FXML private void handleTallenna() {
        Dialogs.showMessageDialog("Tallennetaan! Mutta ei toimi vielä.");
    }
    
    @FXML private void handleUusiPeli() {
        Dialogs.showMessageDialog("Tehdään uusi peli! Mutta ei toimi vielä.");
    }
    
    @FXML private void handleTulosta() {
        Dialogs.showMessageDialog("Tulostetaan! Mutta ei toimi vielä.");
    }
    
    @FXML private void handleParhaat() {
        Parhaat();
        //Dialogs.showMessageDialog("Parhaat! Mutta ei toimi vielä.");
    }
    
    @FXML private void handleLopeta() {
        Dialogs.showMessageDialog("Lopetetaan, mutta ennen kysytään halutaanko varmasti! Mutta ei toimi vielä.");
    }
  //--------------------------------------------//
    
    
    
    //MUOKKAA - kohdan alla menubarissa olevat napit
    @FXML private void handleLisaaPelaajaKorttiin() {
        String lisattava = Dialogs.showInputDialog("Anna lisättävän pelaajan nimi", "pelaaja");
        if ( lisattava == null ) return;
        //Dialogs.showMessageDialog("Lisätään pelaaja korttiin! Mutta ei toimi vielä.");
        lisaaPelaaja();
    }
    
    @FXML private void handlePoistaPelaajaKortista() {
        String poistettava = Dialogs.showInputDialog("Anna poistettavan pelaajan nimi", "pelaaja");
        if ( poistettava == null ) return;
        //Dialogs.showMessageDialog("Poistetaan pelaaja kortista! Mutta ei toimi vielä.");
        poistaPelaaja(poistettava);
    }
    //--------------------------------------------//
    
    
    
    //APUA - kohdan alla menubarissa olevat napit
    @FXML private void handleTietoja() {
        Dialogs.showMessageDialog("Tietoja avautuu tästä! Mutta ei toimi vielä.");
    }
  //--------------------------------------------//
    
    
    
    //Radanvalintanapit
    @FXML private void handleVaihdaRata() {
        Dialogs.showMessageDialog("Vaihdetaan rata! Mutta ei toimi vielä.");
    }
    
    
    @FXML private void handleLisaaRata() {
        LisaaRata();
    }
    
    
    
    
  //--------------------------------------------//
    
    
    
    /**
     * Aliohjelma, joka avaa "parhaat tulokset"-ikkunan pääohjelman ikkunan päälle.
     */
    private void Parhaat() {
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/fxParhaat/ParhaatGUIview.fxml"));
            Parent root = fxmlLoader.load();
            Stage stage = new Stage();
            stage.setTitle("Parhaat tulokset");
            stage.setScene(new Scene(root));
            stage.show();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    
    
    private void LisaaRata() {
        Rata uusi = UusirataGUIController.kysyRata(null, null);     
        if (uusi == null) {     // Dialogista ei tule oikeaa rataa takaisin, tehdään oma
            uusi = new Rata();
        }
        uusi.rekisteroi();
        uusi.vastaaLaajis(1);
        tuloskortti.lisaaRata(uusi);
        //pelaaja4.setText(uusi.getParhaanId() + " " +uusi.getNimi());
        rataValitsin.getItems().addAll(new MenuItem(uusi.getNimi()+
                " PT:"+uusi.getParhaanId() + ", " + uusi.getParasTulos()));
               
    }
    
//    /**
//     * 
//     * @param pelaaja tarkasteltava pelaaja
//     */
//    private void lueTiedosto(String pelaaja) {
//        //TODO
//    }
    
    /**
     * @return Totuusarvon siitä, kirjoitettiinko käyttäjänimeen jotakin.
     * Jos ei kirjoitettu mitään, palauttaa false.
     */
    public boolean avaa() {
        String uusipelaaja = KirjautuminenGUIController.kysyNimi(null, "Pelaaja1");
        if (uusipelaaja == null) return false;
        //lueTiedosto(uusipelaaja);
        return true;
    }
      

    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }
    
    
    //===============================================================================//
    private Tuloskortti tuloskortti; 
    @FXML private TextField pelaaja1;
    @FXML private TextField pelaaja2;
    @FXML private TextField pelaaja3;
    @FXML private TextField pelaaja4;
    @FXML private MenuButton rataValitsin;
    
    
    /** laittaa omaksi tuloskortiksi mainissa luodun tuloskortin,
     * 
     * @param tuloskortti johon alustetaan
     */
    public void setTuloskortti(Tuloskortti tuloskortti) {
        this.tuloskortti = tuloskortti;
    }
    
    
  
    
    
    
    
    /**
     * @param pid etsittävän pelaajan id.
     */
    protected void hae(int pid) {
        
        int indeksi = 0;
        for (int i = 0; i<tuloskortti.getPelaajia(); i++) {
            Pelaaja peluri = tuloskortti.annaPelaaja(i);
            if (peluri.getId() == pid) 
            {
                indeksi = i;
                if (indeksi == 0) pelaaja1.setText(peluri.getNimi());
                if (indeksi == 1) pelaaja2.setText(peluri.getNimi());
                if (indeksi == 2) pelaaja3.setText(peluri.getNimi());
                if (indeksi == 3) pelaaja4.setText(peluri.getNimi());
            }
        }
    }
    
    /**
     * Hakee poistamisen jälkeen kaikki jäljellä olevat pelaajat
     */
    protected void haeKaikki() {
        pelaaja1.clear(); pelaaja2.clear(); pelaaja3.clear(); pelaaja4.clear();
        for (int i = 0; i<tuloskortti.getPelaajia(); i++) {
            
            if (i == 0) pelaaja1.setText(tuloskortti.annaPelaaja(i).getNimi());
            if (i == 1) pelaaja2.setText(tuloskortti.annaPelaaja(i).getNimi());
            if (i == 2) pelaaja3.setText(tuloskortti.annaPelaaja(i).getNimi());
            if (i == 3) pelaaja4.setText(tuloskortti.annaPelaaja(i).getNimi());
        }
    }
    
    /**
     * lisää pelaajan tuloskorttiin.
     */
    protected void lisaaPelaaja() {
        Pelaaja uusi = new Pelaaja();
        uusi.rekisteroi();
        uusi.vastaaPasi();
        try {
            tuloskortti.lisaaPelaaja(uusi);
        }
        catch (SailoException e){
            Dialogs.showMessageDialog("Ongelmia uuden luomisessa " + e.getMessage());
            return;
        }
        hae(uusi.getId());
    }
    
//    /**
//     * lisää uuden radan
//     */
//    protected void lisaaRata() {
//        Rata uusi = new Rata();
//        uusi.rekisteroi();
//        uusi.vastaaLaajis(1);
//        tuloskortti.lisaaRata(uusi);
//        //pelaaja4.setText(uusi.getParhaanId() + " " +uusi.getNimi());
//        rataValitsin.getItems().addAll(new MenuItem(uusi.getNimi()));
//    }    
    
    
    /**
     * @param poistettavanNimi poistettavan pelaajan nimi
     */
    protected void poistaPelaaja(String poistettavanNimi) {
        Pelaaja poistettava; 
        for (int i = 0; i<tuloskortti.getPelaajia(); i++) {
            poistettava = tuloskortti.annaPelaaja(i);
            if (poistettava.getNimi().equals(poistettavanNimi)) {
                tuloskortti.poistaPelaaja(poistettava);
            }
        }
        haeKaikki();
    }
    //private Tuloskortti tuloskortti;
    //private Pelaaja pelaajaKohdalla;
    
    
    
    
    
    
    
    
    
}