package fxTulosKortti;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import luokat.Tuloskortti;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;


/**
 * @author Sakari
 * @version 22.1.2025
 * Pääohjelma Tuloskortti-ohjelman käynnistämiseksi 
 */
public class TuloskorttiMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("TuloskorttiGUIView.fxml"));
            final Pane root = ldr.load();
            final TuloskorttiGUIController tuloskorttiCtrl = (TuloskorttiGUIController) ldr.getController();
            
            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("tuloskortti.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("Tuloskortti");
            
            Tuloskortti tuloskortti = new Tuloskortti();
            tuloskorttiCtrl.setTuloskortti(tuloskortti);
            
            primaryStage.show();
            if ( !tuloskorttiCtrl.avaa() ) Platform.exit();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Käynnistetään käyttöliittymä
     * @param args komentorivin parametrit
     */
    public static void main(String[] args) {
        launch(args);
    }
}