package luokat;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @author Sakari
 * @version 11.3.2025
 *
 */
public class Radat {
    
    private Collection<Rata> radat = new ArrayList<Rata>(); 
    
    
    
    /**
     * @param id parhaan tuloksen id
     * @return radat joiden parhaan tuloksen heittänyt
     * id:n omaava pelaaja.
     * @example
     * <pre name="test">
     * #import java.util.*;
     * 
     * Radat radat = new Radat();
     * Rata laajis01 = new Rata(1); radat.lisaaRata(laajis01);
     * Rata laajis02 = new Rata(3); radat.lisaaRata(laajis02);
     * Rata laajis03 = new Rata(1); radat.lisaaRata(laajis03);
     * Rata laajis04 = new Rata(2); radat.lisaaRata(laajis04);
     * Rata laajis05 = new Rata(4); radat.lisaaRata(laajis05);
     * 
     * List<Rata> loytyneet;
     * loytyneet = radat.annaRadat(5);
     * loytyneet.size() === 0;
     * loytyneet = radat.annaRadat(1);
     * loytyneet.size() === 2;
     * loytyneet.get(0) == laajis01 === true;
     * loytyneet.get(1) == laajis03 === true;
     * loytyneet = radat.annaRadat(4);
     * loytyneet.size() === 1;
     * loytyneet.get(0) == laajis05 === true;
     * </pre>
     */
    public List<Rata> annaRadat(int id){
        List<Rata> loydetyt = new ArrayList<Rata>();
        for (Rata rata : radat) {
            if (rata.getParhaanId() == id) loydetyt.add(rata);
        }
        return loydetyt;
    }
    
    /**
     * @return kuinka monta rataa listassa
     */
    public int koko() {
        return this.radat.size();
    }
    
    /**
     * @param r lisättävä rata
     */
    public void lisaaRata(Rata r) {
        radat.add(r);
    }
    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Radat radat = new Radat();
        Rata laajis = new Rata();
        laajis.vastaaLaajis(1);
        Rata keljo = new Rata();
        keljo.vastaaLaajis(1);
        Rata seppala = new Rata();
        seppala.vastaaLaajis(2);
        
        radat.lisaaRata(laajis);
        laajis.rekisteroi();
        radat.lisaaRata(keljo);
        keljo.rekisteroi();
        radat.lisaaRata(seppala);
        seppala.rekisteroi();
        
        System.out.println("=================== Radat testi ==================");
        
        List <Rata> radat2 = radat.annaRadat(2);
        for (Rata rata : radat2) {
            System.out.print(rata.getParhaanId() + " ");
            rata.tulosta(System.out);
        }
        
    }

}
